<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	
	<title>Bootstrap Flex</title>

	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

	<!-- <link rel="stylesheet" type="text/css" href="./index.css"> -->
</head>
<body>

	<div class="text-center container-fluid">
		<h1>Bootstrap Flex</h1>
		<p> Use the d-flex class to create a flex container and transform direct children into a flex item</p>

		<h2 class="mt-5">Centering Elements</h2>
		<div style="height: 500px;" class="bg-secondary p-3 d-flex  justify-content-center align-items-center flex-column-reverse">
			<!--  
				d-flex will change all of our child div elements into FLEXIBLE items. The flex items will only occupy the space enough for the element's content
			-->
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2 class="mt-5">Flex Row</h2>
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="bg-success p-3">Flex Item A</div>
			<div class="bg-warning p-3">Flex Item B</div>
			<div class="bg-danger p-3">Flex Item C</div>
		</div>

		<h2 class="mt-5">Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="bg-success p-3">Flex Item A</div>
			<div class="bg-warning p-3">Flex Item B</div>
			<div class="bg-danger p-3">Flex Item C</div>
		</div>

		<h2 class="mt-5">Creating Space Between Elements</h2>
		<div class="bg-dark p-3 d-md-flex justify-content-around">
			<!--
				d-xx-flex = will apply flex value to the display property depending on the size indicated (sm, md, lg, xl) 

				justify-content-around = centers elements horizontally while creating space between elements and the border of its parent container 
			-->
			<div class="bg-success p-3 col-md-2">Card A</div>
			<div class="bg-warning p-3 col-md-2">Card B</div>
			<div class="bg-danger p-3 col-md-2">Card C</div>

		</div>

		<h2 class="mt-5">Flexbox with a Margin</h2>
			<div class="bg-dark p-3 d-flex">
				<div class="bg-success p-3 mr-auto">Flex Item A</div>
				<!-- 
					mr-auto = will occupy the remaining width of the container pushing all other elements to the right
				-->
				<div class="bg-warning p-3">Flex Item B</div>
				<div class="bg-danger p-3">Flex Item C</div>
				<div class="bg-primary p-3">Flex Item D</div>
			</div>

		<h2 class="mt-5">Nested Flex Elements</h2>
			<div class="bg-dark p-3 d-block d-md-flex">
			<!--
				d-classes = only applies to its child elements , and not to any of its further descendants 
			 -->
				<div class="bg-success p-3 mr-auto">Flex Item A</div>
				<div class="w-50 d-block d-md-flex justify-content-between bg-light">
				<!-- 
					justify-content-between = similar to justify content around but without padding on left and right
				 -->
					<div class="bg-warning p-3">Flex Item B</div>
					<div class="bg-danger p-3">Flex Item C</div>
					<div class="bg-info p-3">Flex Item D</div>
				</div>
			</div>

	</div>



<!-- JS Dependencies -->
<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>

</body>
</html>